// openMP5.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <omp.h>
#include "math.h"
#include <windows.h>

LARGE_INTEGER GetTickCount2() {
	HANDLE hCurrentProcess = GetCurrentProcess();
	DWORD dwProcessAffinity;
	DWORD dwSystemAffinity;
	LARGE_INTEGER result;

	GetProcessAffinityMask(hCurrentProcess,&dwProcessAffinity, &dwSystemAffinity);
	SetProcessAffinityMask(hCurrentProcess,1);

	QueryPerformanceCounter(&result);

	SetProcessAffinityMask(hCurrentProcess,dwProcessAffinity);

	return result;
}




void test1(int n, int numberThreads) {
	LARGE_INTEGER t1, t2;	// misst die Zeiten
	long zeit;
	t1 = GetTickCount2();
	omp_set_num_threads(numberThreads);
	#pragma omp parallel for // schedule(dynamic,1)  
	for (int i=0; i<n; i++) {
		for (int j=0; j<i; j++) {
			double d= sin(42.42);
		}
	}
	t2 = GetTickCount2();
	zeit = t2.LowPart-t1.LowPart;
	printf("Test1: %d\n",zeit ) ;
}

void test2(int n, int numberThreads) {
	LARGE_INTEGER t1, t2;	// misst die Zeiten
	long zeit;
	t1 = GetTickCount2();
	omp_set_num_threads(numberThreads);
	#pragma omp parallel for schedule(dynamic,1)  
	for (int i=0; i<n; i++) {
		for (int j=0; j<i; j++) {
			double d= sin(42.42);
		}
	}
	t2 = GetTickCount2();
	zeit = t2.LowPart-t1.LowPart;
	printf("Test3: %d\n",zeit ) ;
}

void test3(int n, int numberThreads) {
	LARGE_INTEGER t1, t2;	// misst die Zeiten
	long zeit;
	t1 = GetTickCount2();
	omp_set_num_threads(numberThreads);
	if (numberThreads==2) {
		#pragma omp parallel sections 
		 {
			#pragma omp section
			{
				int id=omp_get_thread_num();
				for (int i=id; i<n; i+=numberThreads) {
					for (int j=0; j<i; j++) {
						double d= sin(42.42);
					}
				}
			}
			#pragma omp section
			{
				int id=omp_get_thread_num();
				for (int i=id; i<n; i+=numberThreads) {
					for (int j=0; j<i; j++) {
						double d= sin(42.42);
					}
				}
			}
		 }  // omp parallel sections shared(sum1,sum2)
	}
	if (numberThreads==4) {
		#pragma omp parallel sections 
		 {
			#pragma omp section
			{
				int id=omp_get_thread_num();
				for (int i=id; i<n; i+=numberThreads) {
					for (int j=0; j<i; j++) {
						double d= sin(42.42);
					}
				}
			}
			#pragma omp section
			{
				int id=omp_get_thread_num();
				for (int i=id; i<n; i+=numberThreads) {
					for (int j=0; j<i; j++) {
						double d= sin(42.42);
					}
				}
			}
			#pragma omp section
			{
				int id=omp_get_thread_num();
				for (int i=id; i<n; i+=numberThreads) {
					for (int j=0; j<i; j++) {
						double d= sin(42.42);
					}
				}
			}
			#pragma omp section
			{
				int id=omp_get_thread_num();
				for (int i=id; i<n; i+=numberThreads) {
					for (int j=0; j<i; j++) {
						double d= sin(42.42);
					}
				}
			}
		 }  // omp parallel sections shared(sum1,sum2)
	}
	t2 = GetTickCount2();
	zeit = t2.LowPart-t1.LowPart;
	printf("Test3: %d\n",zeit ) ;
}

/*
Zeiten
Test1: 94570776
Test3: 68746151
Test3: 65808534
*/

int _tmain(int argc, _TCHAR* argv[]) {
	int n=70000;
	int numberThreads=4;
	test1(n,numberThreads);
	test2(n,numberThreads);
	test3(n,numberThreads);
	return 0;
}

